# -*- coding:Utf-8 -*-


# ====================================================================================================
#
# >> IMPORTATIONS
#
# ====================================================================================================


import es

import psyco
psyco.full()


# ====================================================================================================
#
# >> INFORMATIONS
#
# ====================================================================================================


informations = es.AddonInfo()
informations.name = "Client KeyPress"
informations.basename = "client_keypress"
informations.version = "1.2"
informations.author = "L'In20Cible"
informations.description = "Provides an event fired when a player press/unpress some keys."
informations.url = "http://addons.eventscripts.com/addons/view/client_keypress/"

es.ServerVar("client_keypress_version", informations.version + " by " + informations.author).makepublic()


# ====================================================================================================
#
# >> INITIALIZATION
#
# ====================================================================================================


def load():
   initialize()
   es.load("client_keypress/client_keypress_extended")
   es.loadevents("declare", "addons/eventscripts/client_keypress/client_keypress_ressources.res")
   es.addons.registerClientCommandFilter(ClientCommandFilterCallBack)
   
def initialize():
   es.loadevents("addons/eventscripts/client_keypress/client_keypress_ressources.res")
   
def unload():
   es.unload("client_keypress/client_keypress_extended")
   es.addons.unregisterClientCommandFilter(ClientCommandFilterCallBack)
   
   
# ====================================================================================================
#
# >> FONCTIONS D'APPEL
#
# ====================================================================================================


def ClientCommandFilterCallBack(userid, arguments):
   returnvalue = True
   if arguments[0].startswith(("+", "-")) and len(arguments[0]) > 1:
      keyname = arguments[0].lower()
      if not es.exists("clientcommand", keyname):
         returnvalue = False
      es.event("initialize", "client_keypress")
      es.event("setint", "client_keypress", "userid", userid)
      es.event("setstring", "client_keypress", "keyname", keyname[1:])
      es.event("setint", "client_keypress", "status", 1 if arguments[0][0] == "+" else 0)
      es.event("fire", "client_keypress")
   return returnvalue
   
   
# ====================================================================================================
#
# >> ÉVÉNEMENTS
#
# ====================================================================================================


def es_map_start(event_var):
   initialize()